<?php
/**
* @version $Id: atomsmsdostepjs.php 2016-03-15
* @package Joomla
* @copyright Copyright (C) Atom.SMS http://www.atomsms.pl/
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );

class plgContentAtomsmsdostepjs extends JPlugin {
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage();
	}
	function onContentPrepare($context, &$row, &$myparams, $page = 0) {
		if(($pos = strpos($row->text, '{sms-dostep')) === false)
			return true;
			
		//JFactory::getConfig()->set('config.caching', 0);
		$group = 1;
		$zone = 'strefa1';
		$err = '';
		if($pos2 = strpos($row->text, '}', $pos+11)) {
			$acc = substr($row->text, $pos+11, $pos2-$pos-11);
			$accpars = explode(' ', strtolower($acc));
			foreach($accpars as $accpar) {
				if(!strlen($accpar)) continue;
				switch($accpar[0]) {
					case 'g':
						if(strlen($accpar) == 2
						&& in_array($accpar[1], array('1','2','3')))
							$group = (int)$accpar[1];
						else
							$err .= "Nieprawidlowa grupa cenowa {sms-dostep}<br />\n";
						break;
					case 's':
						$zone = substr($accpar, 1);
						break;
				}
			}
		}
		else
			$err = "Nieprawidlowy kwalifikator {sms-dostep}<br />\n";

		// load atomsms-dostep info
		$plugin = & JPluginHelper::getPlugin('content', 'atomsmsdostepjs');
		$params = $this->params;
		
		$GLOBALS['sms_dostep_prefix'] = $params->get('sms_dostep_prefix', 'MPLX3');
		$GLOBALS['sms_dostep_klucz'] = $params->get('sms_dostep_klucz', '5fe8313c8c77419389e2332c87dd1eda');
		$GLOBALS['sms_dostep_test'] = (int) $params->get('sms_dostep_test', 1);
		$GLOBALS['sms_dostep_kodowanie'] = $params->get('sms_dostep_kodowanie', 'iso');
		switch($params->get('sms_dostep_strefy', '1')) { // definicja stref
			case 'S': $zone = "S{$row->sectionid}"; break;
			case 'C': $zone = "C{$row->catid}"; break;
			case 'A': $zone = "A{$row->id}"; break;
		}
		if($params->get('sms_dostep_diff_ip', '0') == 1)
			$zone .= '-' . $_SERVER['REMOTE_ADDR'];
		require_once( JPATH_SITE . '/plugins/content/atomsmsdostepjs/sms-dostep-j25-js.php' );

		$times = array(1=>'M60', 2=>'H24', 3=>'D7');
		$tars = array(1=>1, 2=>5, 3=>9);
		$paid = false;
		$strefa = sms_dostep_safestr("G{$group}_S{$zone}");
		$GLOBALS['sms-access-tariff'] = array();
		$pwd = substr(md5(time().rand()), 0, 6);
		$tcodes = array();
		for($n = 1; $n <= 3; $n++) {
			$time = $params->get("sms_dostep_czas_{$group}{$n}", $times[$n]);
			if($time == '0') continue;
			$tar = $params->get("sms_dostep_taryfa_{$group}{$n}", $tars[$n]);
			//if($paid = sms_dostep($tar, $time[0], (int)substr($time,1), $strefa, true)) break;
			$GLOBALS['sms-access-tariff'][] = $tar.$time;
			$tcodes = array_merge($tcodes, sms_valid_codes($tar, $time[0], (int)substr($time, 1), $strefa, $pwd));
		}
		if($paid) { // oplacone
			$row->text = preg_replace('/\{sms-dostep[^}]*\}/', '', $row->text);
		}
		else { // nie oplacone
			preg_match('/^(.*)\{sms-dostep[^}]*\}(.*)$/s', $row->text, $regs);
			
			$row->text = $regs[1];
			
			$raw = "<!-- decrypted text -->{$regs[2]}";
			$enc = sms_dostep_encrypt($raw, $pwd);
			
			$code = '<script src="http://app.atomsms.pl/crypto-js/components/core-min.js"></script>
<script src="http://app.atomsms.pl/crypto-js/components/enc-base64-min.js"></script>
<script src="http://app.atomsms.pl/crypto-js/rollups/md5.js"></script>
';

			$code .= "<script>
			function assc(cname, cvalue) {
				var d = new Date();
				d.setTime(d.getTime() + (180*24*60*60*1000));
				var expires = 'expires='+d.toUTCString();
				document.cookie = cname + '=' + cvalue + '; ' + expires;
			}
			function asgc(cname) {
				var name = cname + '=';
				var ca = document.cookie.split(';');
				for(var i=0; i<ca.length; i++) {
					var c = ca[i];
					while (c.charAt(0)==' ') c = c.substring(1);
					if (c.indexOf(name) == 0) return c.substring(name.length,c.length);
				}
				return '';
			} 			
			var ascodes = " . json_encode($tcodes,  128) . ";
			var asenc = '{$enc}';
			function asfdec(pwd) {
				var hpwd = CryptoJS.MD5(pwd).toString();
				var renc = CryptoJS.enc.Base64.parse(asenc).toString(CryptoJS.enc.Utf8);
				var dec = '';
				var lkey = hpwd.length;
				for(var n = 0; n < renc.length; n++) {
					var a = renc.charCodeAt(n);
					var b = hpwd.charCodeAt(n % lkey);
					var c = (a ^ b) % 256;
					dec += String.fromCharCode(c);
				}
				dec = CryptoJS.enc.Base64.parse(dec).toString(CryptoJS.enc.Utf8);
				if(/^<!-- decrypted text -->/.exec(dec)) {
					document.getElementById('asdec').innerHTML = dec;
					document.getElementById('atomsms').style.display = 'none';
					return true;
				}
				else
					return false;
			}
			function asfchk(code, msg) {
				code = code.toUpperCase().replace('O','0').replace('I','1').replace('S','5').replace('G','6');
				var ch = 'C' + CryptoJS.MD5(code).toString().toUpperCase();
				var ok = false;
				if(ascodes[ch]) {
					var pwd = '';
					var n;
					for(var n = 0; n < 6; n++)
						pwd += String.fromCharCode(code.charCodeAt(n) ^ ascodes[ch][n]);
					if(ok = asfdec(pwd))
						assc('sms-dostep-{$strefa}', code);
				}
				if(!ok && msg)
					alert('Podany kod jest nieprawidłowy lub upłynęła jego ważność');
				return false;
			}
			function ascc() {
				var c = asgc('sms-dostep-{$strefa}');
				if(c) asfchk(c, false);
				return false;
			}
			</script>
			<div id='asdec'></div>
			";
			$row->text .= $code . sms_dostep_form($strefa, $row->title);
		}

		if($err) $row->text = $err . $row->text;
		return true;
	}
}
?>